///////////////////////////////////////////////////
/// GDX GEDCOM file list 
/// Written By Michael Gibson under the GPL
/// (c) 2003-2005
//////////////////////////////////////////////////

#include <stdio.h>
#include <string.h>
#include "GDXlib.h"

int button_01,button_02,selectlist;
char namelist[512][512];
void print_report(void);
int indi;
char last_action[5];
char filename[50];
char indi_name[200];
int number_of_names=0;
int x=0;
char temp[200];
FILE *fp;

/////////////////////////////////////////////
///// showdata
////////////////////////////////////////////
void showdata(void){
  char systemstring[300];
  sprintf(filename,"%s",gdx_selectlist_obj.item[gdx_selectlist_obj.selected[selectlist]][selectlist]);
  sprintf(systemstring,"./gedlist %s &",filename);
  system(systemstring);

    gdx_closewindow();
}
/////////////////////////////////////////////////////
///// quit app
/////////////////////////////////////////////////////
static void destroy(void)
{
    gdx_closewindow();
}

//////////////////////////////////////////
/// int main()
/////////////////////////////////////////
int main(int argc, char **argv)
{

  char stringnumofnames[10];
  int label1;

  printf("Start GUI\n");
 
  x_open(); 
                                                                                                                             
  /* create a new window */
  gdx_window("GEDCOM List",400,200); 
  gdx_setwindowbg("images/bg.xpm",1);
  label1 = gdx_label("Select GEDCOM file...",32,14,0);
  gdx_setlabelbg("images/bg.xpm",1,label1);

  button_01 = gdx_imagebutton(5,25,"images/close.xpm",destroy);
  button_02 = gdx_imagebutton(5,50,"images/fileopen.xpm",showdata);
  print_report();
  selectlist = gdx_selectlist(35,25,512,namelist,20,15);
  gdx_main ();
  x_close();
  return(0);
}


//////////////////////////////////////////
/// print_report()
/////////////////////////////////////////
void print_report()
{

  //if windows file system
  #ifdef WIN32
    system("dir /B *.ged >gedfilelist.dat 2>>error_log");
  #endif

  //if all others
  #ifndef WIN32
    system("ls *.ged >gedfilelist.dat 2>>error_log");
    system("ls *.GED >>gedfilelist.dat 2>>error_log");
  #endif


  system("echo end >>gedfilelist.dat");
  if((fp=fopen("gedfilelist.dat","r"))==NULL ){
     printf("GEDCOM file list: Sorry, no file(s) found. \n");
     exit(0);
  }
   number_of_names=-1;
  
  do{
    fgets(temp,80,fp);
    for(x=0;x<50;x++){
      if(temp[x]=='\r' || temp[x]=='\n'){
         temp[x]= ' ';
      }
    }
    number_of_names++;
    strcpy(namelist[number_of_names],temp);
  }while(temp[0] !='e' || temp[2] !='d');
  strcpy(namelist[number_of_names],"    ");
fclose(fp);

}
